IncludeScript(projectDir + "/_charlib/weapon_list.nut");
IncludeScript(projectDir + "/_charlib/custom_sounds.nut");

::ConvertToCustomCharacter <- function(player, includeScript)
{
    ClearCustomCharacter(player);
    player.ValidateScriptScope();
    local playerScope = player.GetScriptScope();
    playerScope.IncludeScript(projectDir+"/_charlib/custom_character.nut");
    try
    {
        playerScope.IncludeScript(includeScript);
    }
    catch (e)
    {
        playerScope.ConvertToCharacterInternal();
        throw e;
    }
    playerScope.ConvertToCharacterInternal();
}

::ClearCustomCharacter <- function(player)
{
    if (IsCustomCharacter(player))
    {
        player.GetScriptScope().ClearCustomCharacterInternal();
        return true;
    }
    return false;
}

::IsCustomCharacter <- function(player, character = null)
{
    local characterName = safeget(safeget(player.GetScriptScope(), "characterSettings", null), "name", null);
    return characterName && (!character || characterName == character);
}

::GetCustomCharacter <- function(player)
{
    player.ValidateScriptScope(); //todo move somewhere better
    return safeget(safeget(player.GetScriptScope(), "characterSettings", null), "name", null);
}

OnGameEvent("post_inventory_application", -20, function(player, params)
{
    local array = charFixArray[player.entindex()];
    local index = array.find(GetCustomCharacter(player));
    if (index != null)
    {
        array.remove(index);
        return 117115;
    }
});

::charFixArray <- player_collection([]);

::CTFPlayer.RespawnFix <- function()
{
    charFixArray[this.entindex()].push(GetCustomCharacter(this));
}
::CTFBot.RespawnFix <- ::CTFPlayer.RespawnFix

::CTFPlayer.HasRespawnFix <- function()
{
    return charFixArray[this.entindex()].find(GetCustomCharacter(this)) != null;
}
::CTFBot.HasRespawnFix <- ::CTFPlayer.HasRespawnFix