::flameCatcherClass <- "obj_teleporter";

//Make projectiles instantly collide with other players
lastProjectileTeam <- TF_TEAM_RED;
AddTimer(-1, 0, function ()
{
    lastProjectileTeam = lastProjectileTeam == TF_TEAM_RED ? TF_TEAM_BLUE : TF_TEAM_RED;
    for (local projectile; projectile = Entities.FindByClassname(projectile, "tf_projectile*");)
        projectile.SetTeam(redTeamOnly ? 3 : lastProjectileTeam);
});

OnGameEvent("OnTakeDamage", 0, function(player, params)
{
    //Caber Fix (didn't use to explode on teammates)
    if (GetPropInt(params.weapon, "m_iDetonated") == 0)
    {
        if (player.GetTeam() != params.attacker.GetTeam())
            return;
        local ogTeam = player.GetTeam();
        player.ForceChangeTeam(player.GetTeam() == TF_TEAM_RED ? TF_TEAM_BLUE : TF_TEAM_RED, false);
        RunWithDelay(-1, function(ogTeam) {
            self.ForceChangeTeam(ogTeam, false);
        }, ogTeam, player)
    }
});

AddTimer(-1, 0, function ()
{
    foreach(player in GetAllPlayers())
    {
        //Demoshield Charge Fix
        if (HasTarge(player))
        {
            local charge = GetPropFloat(player, "m_Shared.m_flChargeMeter");
            if ((GetPropInt(player, "m_nButtons") & IN_ATTACK2) && charge >= 100)
                player.AddCond(TF_COND_SHIELD_CHARGE);
            if (player.InCond(TF_COND_SHIELD_CHARGE))
            {
                if (charge <= 40)
                    player.AddCondEx(TF_COND_CRITBOOSTED_PUMPKIN, 0.75, player);
                else if (charge <= 75)
                    player.AddCondEx(TF_COND_OFFENSEBUFF, 0.75, player);
                if ((GetPropInt(player, "m_nButtons") & IN_ATTACK))
                    SetPropFloat(player, "m_Shared.m_flChargeMeter", 0);
            }
        }

        //Last Weapon Fix
        local weapon = player.GetActiveWeapon();
        local activeSlot = weapon ? weapon.GetSlot() : -1;
        for (local i = 0; i < 10; i++)
        {
            local weaponEnt = GetPropEntityArray(player, "m_hMyWeapons", i);
            if (weaponEnt && weaponEnt.GetSlot() != activeSlot)
                SetPropEntity(player, "m_hLastWeapon", weaponEnt)
        }
    }
});

OnGameEvent("OnTakeDamageNonPlayer", 0, function(params)
{
    local flameCatcher = params.const_entity;
    if (!flameCatcher)
        return;

    local damage = params.damage;
    if (flameCatcher.GetClassname() == flameCatcherClass)
    {
        params.damage = 0;
        params.early_out = true;
    }

    if (!(params.damage_type & (DMG_BURN | DMG_PLASMA)) && !(params.damage_custom | TF_DMG_CUSTOM_PENETRATE_MY_TEAM))
        return;

    local attacker = params.attacker;
    if (!attacker)
        return;

    local parent = flameCatcher.GetMoveParent();
    if (attacker != parent && IsValidPlayer(parent))
    {
        local weapon = attacker.GetActiveWeapon();
        if (weapon)
            weapon.AddAttribute("item_meter_charge_rate", 0.8, -1)
        parent.TakeDamageCustom(
            attacker,
            attacker,
            weapon,
            params.damage_force,
            params.damage_position,
            damage
            params.damage_type,
            params.damage_custom);
    }
})