::WEAPON_TYPES <- [
    {
        names = ["crowbar", "tf_weapon_crowbar"],
        displayname = "Crowbar",
        baseclass = "tf_weapon_shovel",
        baseid = 196,
        animmodel = "models/weapons/v_models/v_crowbar_mercenary.mdl",
        weaponmodel = "models/weapons/c_models/c_crowbar.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("fire rate bonus HIDDEN", 0.5, -1);
            weaponEnt.AddAttribute("damage penalty", 0.55, -1);
            weaponEnt.AddAttribute("mod crit while airborne", 1, -1);
            weaponEnt.AddAttribute("crit kill will gib", 1, -1);
            weaponEnt.AddAttribute("melee range multiplier", 1.15, -1);
            weaponEnt.AddAttribute("melee bounds multiplier", 1.1, -1);
        }
    },
    {
        names = ["brick"],
        displayname = "brick",
        baseclass = "tf_weapon_shovel",
        animmodel = "models/empty.mdl",
        weaponmodel = "models/empty.mdl",
        baseid = 196,
    },
    {
        names = ["flamethrower"],
        displayname = "Flamethrower",
        baseclass = "tf_weapon_flamethrower",
        playerclass = TF_CLASS_PYRO
        animmodel = "models/dmgg/weapons/merc_arms/merc_pyro_arms.mdl",
        playermodel = "models/dmgg/player/merc_flamethrower.mdl"
        baseid = 21,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(200);
            RunWithDelay(0.1, function() {
                self.SetClip1(200);
            }, weaponEnt)
            SetPropIntArray(player, "m_iAmmo", 200, 1);
        }
    },
    {
        names = ["phlogistinator"],
        displayname = "Phlogistinator",
        baseclass = "tf_weapon_flamethrower",
        playerclass = TF_CLASS_PYRO
        animmodel = "models/dmgg/weapons/merc_arms/merc_pyro_arms.mdl",
        playermodel = "models/dmgg/player/merc_flamethrower.mdl"
        baseid = 594,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(200);
            RunWithDelay(0.1, function() {
                self.SetClip1(200);
            }, weaponEnt)
            SetPropIntArray(player, "m_iAmmo", 200, 1);
        }
    },
    {
        names = ["pistol"],
        displayname = "Pistol",
        baseclass = "tf_weapon_pistol",
        baseid = 22,
        playerclass = TF_CLASS_ENGINEER
        animmodel = "models/dmgg/weapons/merc_arms/merc_engineer_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 200, 2);
        }
    }
    {
        names = ["pocket_pistol"],
        displayname = "Pretty Boy's Pocket Pistol",
        baseclass = "tf_weapon_handgun_scout_secondary",
        playerclass = TF_CLASS_SCOUT
        baseid = 773,
        animmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 200, 1);
        }
    }
    {
        names = ["revolver"],
        displayname = "Revolver",
        baseclass = "tf_weapon_revolver",
        playerclass = TF_CLASS_SPY
        baseid = 24,
        animmodel = "models/dmgg/weapons/merc_arms/merc_spy_arms.mdl",
        playermodel = "models/dmgg/player/merc_sniper.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    }
    {
        names = ["ambassador"],
        displayname = "Ambassador",
        baseclass = "tf_weapon_revolver",
        playerclass = TF_CLASS_SPY
        baseid = 61,
        animmodel = "models/dmgg/weapons/merc_arms/merc_spy_arms.mdl",
        playermodel = "models/dmgg/player/merc_sniper.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    }
    {
        names = ["shortstop"],
        displayname = "Shortstop",
        baseclass = "tf_weapon_handgun_scout_primary",
        playerclass = TF_CLASS_SCOUT
        baseid = 220,
        animmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    }
    {
        names = ["force_a_nature"],
        displayname = "Force-a-Nature",
        baseclass = "tf_weapon_scattergun",
        playerclass = TF_CLASS_SCOUT
        animmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        baseid = 45,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(2);
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    }
    {
        names = ["soda_popper"],
        displayname = "Soda Popper",
        baseclass = "tf_weapon_soda_popper",
        playerclass = TF_CLASS_SCOUT
        animmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        baseid = 448,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(2);
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    }
    {
        names = ["loch_n_load"],
        displayname = "Loch-n-Load",
        baseclass = "tf_weapon_grenadelauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 308,
        animmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/dmgg/player/merc_grenade.mdl"
    }
    {
        names = ["shotgun"],
        displayname = "Shotgun",
        baseclass = "tf_weapon_shotgun_soldier",
        animmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl"
        playermodel = "models/dmgg/player/merc_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 199,
    }
    {
        names = ["family_business"],
        displayname = "Family Business",
        baseclass = "tf_weapon_shotgun_hwg",
        animmodel = "models/dmgg/weapons/merc_arms/merc_heavy_arms.mdl",
        playermodel = "models/dmgg/player/merc_rocket.mdl"
        playerclass = TF_CLASS_HEAVY
        baseid = 425,
    }
    {
        names = ["smg"],
        displayname = "SMG",
        baseclass = "tf_weapon_smg",
        playerclass = TF_CLASS_SNIPER
        baseid = 16,
        animmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl"
        playermodel = "models/dmgg/player/merc_minigun.mdl"
    }
    {
        names = ["syringe_gun"],
        displayname = "Syringe Gun",
        baseclass = "tf_weapon_syringegun_medic",
        playerclass = TF_CLASS_MEDIC
        baseid = 17,
        animmodel = "models/dmgg/weapons/merc_arms/merc_medic_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 150, 1);
        }
    }
    {
        names = ["crusaders_crossbow"], //todo fix
        displayname = "Crusader's Crossbow",
        baseclass = "tf_weapon_crossbow",
        playerclass = TF_CLASS_MEDIC
        baseid = 305,
        animmodel = "models/dmgg/weapons/merc_arms/merc_medic_arms.mdl"
        onPullOut = function(player, weapon) {
            //weapon.AddAttribute("override projectile type", 11, -1);
        }
    }
    {
        names = ["minigun"],
        displayname = "Minigun",
        baseclass = "tf_weapon_minigun",
        playerclass = TF_CLASS_HEAVY
        baseid = 15,
        animmodel = "models/dmgg/weapons/merc_arms/merc_heavy_arms.mdl",
        playermodel = "models/dmgg/player/merc_minigun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(200);
            RunWithDelay(0.1, function() {
                self.SetClip1(200);
            }, weaponEnt)
            SetPropIntArray(player, "m_iAmmo", 200, 1);
        }
    }
    {
        names = ["tomislav"],
        displayname = "Tomislav",
        baseclass = "tf_weapon_minigun",
        playerclass = TF_CLASS_HEAVY
        baseid = 424,
        animmodel = "models/dmgg/weapons/merc_arms/merc_heavy_arms.mdl",
        playermodel = "models/dmgg/player/merc_minigun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(200);
            RunWithDelay(0.1, function() {
                self.SetClip1(200);
            }, weaponEnt);
            SetPropIntArray(player, "m_iAmmo", 200, 1);
        }
    }
    {
        names = ["rocket_launcher"],
        displayname = "Rocket Launcher",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/dmgg/player/merc_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 18,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("rocket jump damage reduction", 0.4, -1);
        }
    }
    {
        names = ["original"],
        displayname = "Rocket Launcher",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/dmgg/player/merc_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 513,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("rocket jump damage reduction", 0.4, -1);
        }
    }
    {
        names = ["liberty_launcher"],
        displayname = "Liberty Launcher",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/dmgg/player/merc_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 414,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("rocket jump damage reduction", 0.4, -1);
        }
    }
    {
        names = ["black_box"],
        displayname = "Black Box",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/dmgg/player/merc_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 228,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("rocket jump damage reduction", 0.4, -1);
        }
    }
    {
        names = ["airstrike"],
        displayname = "Airstrike",
        baseclass = "tf_weapon_rocketlauncher_airstrike",
        animmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/dmgg/player/merc_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 1104,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("rocket jump damage reduction", 0.4, -1);
        }
    }
    {
        names = ["grenade_launcher"],
        displayname = "Grenade Launcher",
        baseclass = "tf_weapon_grenadelauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 19,
        animmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/dmgg/player/merc_grenade.mdl"
    }
    {
        names = ["iron_bomber"],
        displayname = "Iron Bomber",
        baseclass = "tf_weapon_grenadelauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 1151,
        animmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/dmgg/player/merc_grenade.mdl"
    }
    {
        names = ["sticky_launcher"],
        displayname = "Sticky Launcher",
        baseclass = "tf_weapon_pipebomblauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 20,
        animmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl",
        playermodel = "models/dmgg/player/merc_grenade.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("rocket jump damage reduction", 0.4, -1);
        }
    }
    {
        names = ["quickie_launcher"],
        displayname = "Quickie Launcher",
        baseclass = "tf_weapon_pipebomblauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 1150,
        animmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/dmgg/player/merc_grenade.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("stickies detonate stickies", 0, -1);
            weaponEnt.AddAttribute("rocket jump damage reduction", 0.4, -1);
        }
    }
    {
        names = ["direct_hit"],
        displayname = "Direct Hit",
        baseclass = "tf_weapon_rocketlauncher_directhit",
        animmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/dmgg/player/merc_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 127,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("rocket jump damage reduction", 0.4, -1);
        }
    },
    {
        names = ["beggars_bazooka"],
        displayname = "Beggar's Bazooka",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/dmgg/player/merc_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 730,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("rocket jump damage reduction", 0.4, -1);
        }
    },
    {
        names = ["scattergun"],
        displayname = "Scattergun",
        baseclass = "tf_weapon_scattergun",
        playerclass = TF_CLASS_SCOUT
        baseid = 13,
        animmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        names = ["back_scatter"],
        displayname = "Back Scatter",
        baseclass = "tf_weapon_scattergun",
        playerclass = TF_CLASS_SCOUT
        baseid = 1103,
        animmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        names = ["baby_faces_blaster"],
        displayname = "Baby Face's Blaster",
        baseclass = "tf_weapon_pep_brawler_blaster",
        playerclass = TF_CLASS_SCOUT
        baseid = 772,
        animmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        names = ["sniper_rifle"],
        displayname = "Sniper Rifle",
        baseclass = "tf_weapon_sniperrifle",
        playerclass = TF_CLASS_SNIPER
        baseid = 14,
        animmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl",
        playermodel = "models/dmgg/player/merc_sniper.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
            foreach(flameCatcher in player.GetAttachments())
                if (flameCatcher.GetClassname() == flameCatcherClass)
                {
                    flameCatcher.KeyValueFromVector("mins", Vector(-5, -5, 0));
                    flameCatcher.KeyValueFromVector("maxs", Vector(5, 5, 40));
                }
        }
    },
    {
        names = ["awper_hand"],
        displayname = "AWPer Hand",
        baseclass = "tf_weapon_sniperrifle",
        playerclass = TF_CLASS_SNIPER
        baseid = 851,
        animmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl",
        playermodel = "models/dmgg/player/merc_sniper.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
            foreach(flameCatcher in player.GetAttachments())
                if (flameCatcher.GetClassname() == flameCatcherClass)
                {
                    flameCatcher.KeyValueFromVector("mins", Vector(-5, -5, 0));
                    flameCatcher.KeyValueFromVector("maxs", Vector(5, 5, 40));
                }
        }
    },
    {
        names = ["sydney_sleeper"],
        displayname = "Sydney Sleeper",
        baseclass = "tf_weapon_sniperrifle",
        playerclass = TF_CLASS_SNIPER
        baseid = 230,
        animmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl",
        playermodel = "models/dmgg/player/merc_sniper.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
        }
    },
    {
        names = ["rescue_ranger"],
        displayname = "Rescue Ranger",
        baseclass = "tf_weapon_shotgun_building_rescue",
        playerclass = TF_CLASS_ENGINEER
        baseid = 997,
        animmodel = "models/dmgg/weapons/merc_arms/merc_engineer_arms.mdl",
        playermodel = "models/dmgg/player/merc_ssg.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        names = ["pomson_6000"],
        displayname = "Pomson 6000",
        baseclass = "tf_weapon_drg_pomson",
        playerclass = TF_CLASS_ENGINEER
        baseid = 588,
        animmodel = "models/dmgg/weapons/merc_arms/merc_engineer_arms.mdl"
    },
    {
        names = ["righteous_bison"],
        displayname = "Righteous Bison",
        baseclass = "tf_weapon_raygun",
        playerclass = TF_CLASS_SOLDIER
        baseid = 442,
        animmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/dmgg/player/merc_sniper.mdl"
    },
    {
        names = ["flaregun"],
        displayname = "Flaregun",
        baseclass = "tf_weapon_flaregun",
        playerclass = TF_CLASS_PYRO
        baseid = 39,
        animmodel = "models/dmgg/weapons/merc_arms/merc_pyro_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        names = ["detonator"],
        displayname = "Detonator",
        baseclass = "tf_weapon_flaregun",
        playerclass = TF_CLASS_PYRO
        baseid = 351,
        animmodel = "models/dmgg/weapons/merc_arms/merc_pyro_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        names = ["scorch_shot"],
        displayname = "Scorch Shot",
        baseclass = "tf_weapon_flaregun",
        playerclass = TF_CLASS_PYRO
        baseid = 740,
        animmodel = "models/dmgg/weapons/merc_arms/merc_pyro_arms.mdl",
        playermodel = "models/dmgg/player/merc_flamethrower.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        names = ["machina"],
        displayname = "Machina",
        baseclass = "tf_weapon_sniperrifle",
        playerclass = TF_CLASS_SNIPER
        baseid = 526,
        animmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
        }
    },
    {
        names = ["classic"],
        displayname = "Classic",
        baseclass = "tf_weapon_sniperrifle_classic",
        baseid = 1098,
        animmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl",
        playerclass = TF_CLASS_SNIPER
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
        }
    },
    {
        names = ["huntsman"],
        displayname = "Huntsman",
        baseclass = "tf_weapon_compound_bow",
        playerclass = TF_CLASS_SNIPER
        baseid = 56,
        animmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl",
        playermodel = "models/dmgg/player/merc_grenade.mdl"
    },
    {
        names = ["loose_cannon"],
        displayname = "Loose Cannon",
        baseclass = "tf_weapon_cannon",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 996,
        animmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/dmgg/player/merc_grenade.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("damage bonus", 1.35, -1);
        }
    },
    {
        names = ["dragons_fury"],
        displayname = "Dragon's Fury",
        baseclass = "tf_weapon_rocketlauncher_fireball",
        animmodel = "models/dmgg/weapons/merc_arms/merc_pyro_arms.mdl",
        playermodel = "models/dmgg/player/merc_flamethrower.mdl"
        playerclass = TF_CLASS_PYRO
        baseid = 1178,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(40);
            RunWithDelay(0.1, function() {
                self.SetClip1(40);
            }, weaponEnt)
            SetPropIntArray(player, "m_iAmmo", 40, 1);

            weaponEnt.AddAttribute("item_meter_charge_type", 1, -1)
            weaponEnt.AddAttribute("item_meter_charge_rate", 0.8, -1)
            weaponEnt.AddAttribute("hidden primary max ammo bonus", 0.2, -1)
            weaponEnt.AddAttribute("airblast cost scale hidden", 0.25, -1)
            weaponEnt.AddAttribute("dragons fury neutral properties", 1, -1)
            weaponEnt.AddAttribute("dragons fury positive properties", 1, -1)
            weaponEnt.AddAttribute("dragons fury negative properties", 1, -1)
        }
        OnFire = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("item_meter_charge_rate", 1.19, -1);
        }
    },
    {
        names = ["jarate_and_bushwacka"],
        displayname = "Jarate & Bushwacka",
        baseclass = "tf_weapon_club",
        baseid = 232,
        playerclass = TF_CLASS_SNIPER
        animmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("effect bar recharge rate increased", 0.35, -1)
            player.GetScriptScope().EquipWeapon(GetWeaponTypeByName("jarate"));
        }
    },
    {
        names = ["jarate"],
        displayname = "Jarate",
        baseclass = "tf_weapon_jar",
        baseid = 58
    },
    {
        names = ["eyelander_and_targe"],
        displayname = "Eyelander & Chargin' Targe",
        baseclass = "tf_weapon_sword",
        baseid = 132,
        playerclass = TF_CLASS_DEMOMAN,
        animmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl",
        playermodel = "models/dmgg/player/merc_grenade.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropInt(player, "m_Shared.m_bShieldEquipped", 1);
            //weaponEnt.AddAttribute("charge recharge rate increased", 1.5, -1);
            weaponEnt.AddAttribute("charge recharge rate increased", 2.5, -1);
            weaponEnt.AddAttribute("dmg taken from fire reduced", 0.5, -1);
            weaponEnt.AddAttribute("dmg taken from blast reduced", 0.7, -1);
            weaponEnt.AddAttribute("melee range multiplier", 1.15, -1);
            weaponEnt.AddAttribute("melee bounds multiplier", 1.15, -1);
            weaponEnt.AddAttribute("max health additive penalty", 0, -1);
            RunWithDelay(0.1, function() {
                CreateViewModel("models/weapons/c_models/c_targe/c_targe.mdl");
                CreateWorldModel("models/weapons/c_models/c_targe/c_targe.mdl");
            }, player);

            foreach(flameCatcher in player.GetAttachments())
                if (flameCatcher.GetClassname() == flameCatcherClass)
                {
                    flameCatcher.KeyValueFromVector("mins", player.GetBoundingMins() + Vector(10, 10, 10))
                    flameCatcher.KeyValueFromVector("maxs", player.GetBoundingMaxs() - Vector(10, 10, 20))
                }
        }
    },
    {
        names = ["persuader_and_screen"],
        displayname = "Persian Persuader & Splendid Screen",
        baseclass = "tf_weapon_sword",
        baseid = 404,
        playerclass = TF_CLASS_DEMOMAN,
        animmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropInt(player, "m_Shared.m_bShieldEquipped", 1);
            weaponEnt.AddAttribute("charge recharge rate increased", 2.0, -1);
            weaponEnt.AddAttribute("charge impact damage increased", 1.7, -1);
            weaponEnt.AddAttribute("dmg taken from fire reduced", 0.8, -1);
            weaponEnt.AddAttribute("dmg taken from blast reduced", 0.8, -1);
            weaponEnt.AddAttribute("melee range multiplier", 1.15, -1);
            weaponEnt.AddAttribute("melee bounds multiplier", 1.15, -1);
            RunWithDelay(0.1, function() {
                CreateViewModel("models/workshop/weapons/c_models/c_persian_shield/c_persian_shield.mdl");
                CreateWorldModel("models/workshop/weapons/c_models/c_persian_shield/c_persian_shield.mdl");
            }, player);
        }
    },
    {
        names = ["fists_of_steel"],
        displayname = "Fists Of Steel",
        baseclass = "tf_weapon_fists",
        playerclass = TF_CLASS_HEAVY
        animmodel = "models/dmgg/weapons/merc_arms/merc_heavy_arms.mdl",
        baseid = 331
    },
    {
        names = ["caber_and_splendid_screen"],
        displayname = "Caber & Splendid Screen",
        baseclass = "tf_weapon_stickbomb",
        baseid = 307,
        playerclass = TF_CLASS_DEMOMAN,
        animmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropInt(player, "m_Shared.m_bShieldEquipped", 1);
            weaponEnt.AddAttribute("charge recharge rate increased", 2.0, -1);
            weaponEnt.AddAttribute("charge impact damage increased", 1.7, -1);
            weaponEnt.AddAttribute("melee range multiplier", 1.15, -1);
            weaponEnt.AddAttribute("melee bounds multiplier", 1.1, -1);
            RunWithDelay(0.1, function() {
                CreateViewModel("models/workshop/weapons/c_models/c_persian_shield/c_persian_shield.mdl");
                CreateWorldModel("models/workshop/weapons/c_models/c_persian_shield/c_persian_shield.mdl");
            }, player);
        }
    },
    {
        names = ["golden_crowbar"],
        displayname = "Golden Crowbar",
        baseclass = "tf_weapon_shovel",
        baseid = 196,
        animmodel = "models/weapons/v_models/v_crowbar_golden_mercenary.mdl",
        weaponmodel = "models/weapons/c_models/c_crowbar_golden.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            player.KeyValueFromString("targetname", "player"+player.entindex());
            local mercColor = player.GetScriptScope().CalcMercColor();
            RunWithDelay(0.1, function(weaponEnt) {
                GetPropEntity(self, "m_hViewModel").DisableDraw();
                weaponEnt.DisableDraw();
            }, weaponEnt, player)
            SetPropBool(SpawnEntityFromTable("tf_glow", {
                target = "player"+player.entindex()
                StartDisabled = 0
                GlowColor = mercColor[0]+" "+mercColor[1]+" "+mercColor[2]+" 255"
            }), "m_bForcePurgeFixedupStrings", true);
            weaponEnt.AddAttribute("fire rate bonus HIDDEN", 0.5, -1);
            weaponEnt.AddAttribute("damage penalty", 0.55, -1);
            weaponEnt.AddAttribute("turn to gold", 1, -1);
            weaponEnt.AddAttribute("melee range multiplier", 1.25, -1);
            weaponEnt.AddAttribute("melee bounds multiplier", 1.25, -1);
        }
    },
    {
        names = ["victory"],
        displayname = "Victory",
        baseclass = "tf_weapon_shovel",
        playerclass = TF_CLASS_SOLDIER
        baseid = 196,
    },
];

RunWithDelay(0.01, function()
{
    foreach (weaponType in WEAPON_TYPES)
    {
        PrecacheModel(safeget(weaponType, "animmodel", null));
        PrecacheModel(safeget(weaponType, "weaponmodel", null));
        PrecacheModel(safeget(weaponType, "playermodel", null));
    }
});